package cz.muni.fi.pa165.entity;

import cz.muni.fi.pa165.entity.interfaces.ExternalAccess;
import cz.muni.fi.pa165.entity.interfaces.Viewable;
import cz.muni.fi.pa165.enums.CountryEnum;
import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Entity;
import java.util.ArrayList;
import java.time.LocalDate;

/**
 * @author mvalko
 */

@Entity
@Data
public class PersonEntity extends BaseEntity implements ExternalAccess, Viewable {

    @Column(nullable = false)
    private String name;

    private LocalDate dateOfBirth;

    private CountryEnum country;

    public PersonEntity() {
    }

    public PersonEntity(String name){
        this.name = name;
    }

    public PersonEntity(String name, LocalDate dateOfBirth, CountryEnum country){
        this(name);
        this.dateOfBirth = dateOfBirth;
        this.country = country;
    }

    @Override
    public boolean login() {
        return false;
    }

    @Override
    public boolean changePassword() {
        return false;
    }

    @Override
    public ArrayList<String> getInformation() {
        return null;
    }

    @Override
    public String getConcreteInformation() {
        return null;
    }
}
