package cz.muni.fi.pa165.services;

import cz.muni.fi.pa165.dao.BaseDao;
import cz.muni.fi.pa165.entity.BaseEntity;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.UUID;

/**
 * @author Dominik Kozubík
 */
public abstract class BaseServiceImpl<Entity extends BaseEntity, Dao extends BaseDao<Entity>> implements BaseService<Entity, Dao> {

    @Autowired
    protected Dao dao;

    @Override
    public void create(Entity t) {
        if (t == null) {
            throw new IllegalArgumentException("Given entity is null.");
        }
        dao.create(t);
    }

    @Override
    public List<Entity> findAll() {
        return dao.findAll();
    }

    @Override
    public Entity findById(UUID id) {
        if (id == null) {
            throw new IllegalArgumentException("Given id is null.");
        }
        return dao.findById(id);
    }

    @Override
    public void update(Entity t) {
        if (t == null) {
            throw new IllegalArgumentException("Given entity is null.");
        }
        dao.update(t);
    }

    @Override
    public void remove(Entity t) {
        if (t == null) {
            throw new IllegalArgumentException("Given entity is null.");
        }
        dao.remove(t);
    }
}
