package cz.muni.fi.pa165.services.tournament;

import cz.muni.fi.pa165.entity.TeamEntity;
import cz.muni.fi.pa165.entity.TournamentEntity;
import cz.muni.fi.pa165.dao.tournament.TournamentDao;
import cz.muni.fi.pa165.services.BaseServiceImpl;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author Dominik Kozubík
 */
@Service
@Transactional
public class TournamentServiceImpl extends BaseServiceImpl<TournamentEntity, TournamentDao> implements TournamentService {

    @Override
    public List<TournamentEntity> getTournamentsByCity(String cityName) {
        if (cityName == null) {
            throw new IllegalArgumentException("Given city name parameter is null.");
        }
        return dao.findAll()
                .stream()
                .filter(tournamentEntity -> tournamentEntity.getCity().equals(cityName))
                .collect(Collectors.toList());
    }

    @Override
    public List<TournamentEntity> getTournamentsWonBy(TeamEntity team) {
        if (team == null) {
            throw new IllegalArgumentException("Given team is null.");
        }
        return dao.findAll()
                .stream()
                .filter(tournamentEntity -> tournamentEntity.getWinner().equals(team))
                .collect(Collectors.toList());
    }
}
